From: Eric Wong <e@yhbt.net>
To: meta@public-inbox.org
Subject: [PATCH 2/2] learn: support --all with `rm'
Date: Tue, 26 May 2020 09:05:24 +0000 [thread overview]
Message-ID: <20200526090524.2831-3-e@yhbt.net> (raw)
In-Reply-To: <20200526090524.2831-1-e@yhbt.net>
I found myself wanting to remove a message from all inboxes
while working on a test case in another branch. I figure this
could also be useful for globally removing messages which are in
the grey area or too big for spamc.
---
Documentation/public-inbox-learn.pod | 8 ++++++--
script/public-inbox-learn | 9 +++++++--
2 files changed, 13 insertions(+), 4 deletions(-)
diff --git a/Documentation/public-inbox-learn.pod b/Documentation/public-inbox-learn.pod
index addcbcb5113..9c6b261b3a5 100644
--- a/Documentation/public-inbox-learn.pod
+++ b/Documentation/public-inbox-learn.pod
@@ -50,8 +50,12 @@ C<publicinboxmda.spamcheck> is C<none> in L<public-inbox-config(5)>.
=item rm
-This is identical to the C<spam> command above, but does
-not feed the message to L<spamc(1)>
+This is similar to the C<spam> command above, but does
+not feed the message to L<spamc(1)> and only removes messages
+which match on any of the C<To:>, C<Cc:>, and C<List-ID:> headers.
+
+The C<--all> option may be used match C<spam> semantics in removing
+the message from all configured inboxes.
=back
diff --git a/script/public-inbox-learn b/script/public-inbox-learn
index 0cb2c8e96e5..5cd08d490bf 100644
--- a/script/public-inbox-learn
+++ b/script/public-inbox-learn
@@ -12,10 +12,15 @@ use PublicInbox::InboxWritable;
use PublicInbox::Eml;
use PublicInbox::Address;
use PublicInbox::Spamcheck::Spamc;
+use Getopt::Long qw(:config gnu_getopt no_ignore_case auto_abbrev);
+my %opt = (all => 0);
+GetOptions(\%opt, 'all') or die "bad command-line args\n";
+
my $train = shift or die "usage: $usage\n";
if ($train !~ /\A(?:ham|spam|rm)\z/) {
die "`$train' not recognized.\nusage: $usage\n";
}
+die "--all only works with `rm'\n" if $opt{all} && $train ne 'rm';
my $spamc = PublicInbox::Spamcheck::Spamc->new;
my $pi_config = PublicInbox::Config->new;
@@ -68,12 +73,12 @@ sub remove_or_add ($$$$) {
}
# spam is removed from all known inboxes since it is often Bcc:-ed
-if ($train eq 'spam') {
+if ($train eq 'spam' || ($train eq 'rm' && $opt{all})) {
$pi_config->each_inbox(sub {
my ($ibx) = @_;
$ibx = PublicInbox::InboxWritable->new($ibx);
my $im = $ibx->importer(0);
- $im->remove($mime, 'spam');
+ $im->remove($mime, $train);
$im->done;
});
} else {
prev parent reply other threads:[~2020-05-26 9:05 UTC|newest]
Thread overview: 3+ messages / expand[flat|nested] mbox.gz Atom feed top
2020-05-26 9:05 [PATCH 0/2] -learn fixes and updates Eric Wong
2020-05-26 9:05 ` [PATCH 1/2] learn: fix buggy typo on List-ID mapping Eric Wong
2020-05-26 9:05 ` Eric Wong [this message]
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
List information: https://public-inbox.org/README
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20200526090524.2831-3-e@yhbt.net \
--to=e@yhbt.net \
--cc=meta@public-inbox.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
Code repositories for project(s) associated with this public inbox
https://80x24.org/public-inbox.git
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).